<?php if (!defined('PmWiki')) exit();
/**
 * qnotes.link.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2010-2019
 * @note This file is part of Cookbook recipe "QNotes" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package qnotes
 */

// **********************************************************
// Links to nodes/qnotes
// **********************************************************
//(:qnotes 'link' 'link' 'QNotes.Notes1' category='/default' :)

    global $QNotes;

    if( ! $QNotes['isResolveLinkOnPageLoad'] ) {
      if($_GET['async'] != '1' && $_GET['qfmt'] != 'html' && $_GET['action'] != 'qnotes') {
        return $qnotesOutFmt = $QNotes['qnotesLinkNoResolveOnPageLoad'];
      }
    }

    $id = &$args[''][0];
    $qnDrawType = &$args[''][1];
    $qnp = &$args[''][2];
    $qn = &$args['category'];

    $t= $qnp.'::'.$qn;

    if(is_array($QNotes['linkscyc']) && count($QNotes['linkscyc']) == 1) {
      $qnotesOutFmt = $QNotes['qnotesSelfLink']; //self links
    } else {
      $qnotesOutFmt = $QNotes['qnotesRecursiveLink']; //cyclic links
    }
    if(is_array($QNotes['linkscyc']) && in_array($t, $QNotes['linkscyc'])) {
      unset($QNotes['linkscyc']); return; //stops cyclic links
    }
    $QNotes['linkscyc'][] = $t;

    //$GLOBALS['RedoMarkupLine']++;
    if(PageExists($qnp)) {
      $page = qnotes_get_page($qnp);
      $qnotesOutFmt = trim(qnotes_nodetext_get_bycategory($qnp, $qn, $page, 0));
    } else {
      $qnotesOutFmt = $QNotes['qnotesPageNotFound'];
    }
    if( ! trim($qnotesOutFmt)) $qnotesOutFmt = $QNotes['qnotesNoteNotFound'];

    $qnotesOutFmt = "\n(:div500 class='qnotelink':)\n" . $qnotesOutFmt . "\n(:div500end:)";
    $qnotesOutFmt = Keep(MarkupToHTML($qnp, $qnotesOutFmt));
    unset($QNotes['linkscyc']);

    return;


